%define name                    sblim-cim-client2
%define project_folder			%{name}-%{version}-src
%define archive_folder			build
%define version                 HEAD
%define release                 1jpp
%define section                 free

# -----------------------------------------------------------------------------

Name:           %{name}
Version:        %{version}
Release:        %{release}
Epoch:          0
License:        Eclipse Public License
Url:            http://sblim.sourceforge.net/
Group:          Development/Libraries/Java
Vendor:         IBM
Distribution:   JPackage
Summary:        Java CIM Client library

BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot
SOURCE:         %{name}-%{version}-src.tar.bz2

BuildArch:      noarch

BuildRequires:  jpackage-utils >= 0:1.5.32
BuildRequires:  ant >= 0:1.6

Requires:       jpackage-utils >= 0:1.5.32

%description
The purpose of this package is to provide a CIM Client Class Library for Java
applications. It complies to the DMTF standard CIM Operations over HTTP and 
intends to be compatible with JCP JSR48 once it becomes available. To learn
more about DMTF visit http://www.dmtf.org.
More infos about the Java Community Process and JSR48 can be found at
http://www.jcp.org and http://www.jcp.org/en/jsr/detail?id=48.

# -----------------------------------------------------------------------------

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

# -----------------------------------------------------------------------------

%package manual
Summary:        Manual and sample code for %{name}
Group:          Development/Documentation

%description manual
Manual and sample code for %{name}.

# -----------------------------------------------------------------------------

%prep
%setup -q -n %{project_folder}

dos2unixConversion() {
	fileName=$1
	%{__sed} -i 's/\r//g' "$fileName"
}

dosFiles2unix() {
	fileList=$1
	for fileName in $fileList; do
		dos2unixConversion $fileName
	done
}

dosFiles2unix 'COPYING sblim-cim-client2.properties sblim-slp-client2.properties'

# -----------------------------------------------------------------------------

%build
# export CLASSPATH=$(build-classpath)
export ANT_OPTS="-Xmx256m"
ant \
        -Dbuild.compiler=modern \
        -DManifest.version=%{version}\
        package java-doc

# -----------------------------------------------------------------------------

%install
RPM_BUILD_ROOT=`echo "$RPM_BUILD_ROOT" | sed -r 's/\/+$//'`
if [ -z $RPM_BUILD_ROOT ]; then
	echo "RPM_BUILD_ROOT must be set."
fi

dirs='/ /bin /dev /home /mnt /sbin /srv /var /boot /etc /lib /media /opt /root /selinux /usr'
for dir in $dirs; do
	if [ "$RPM_BUILD_ROOT" = "$dir" ]; then
		echo "$dir for RPM_BUILD_ROOT is evil!"
		exit 1
	fi
done

rm -rf $RPM_BUILD_ROOT

# --- documentation ---
dstDocDir=$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -d $dstDocDir
install --mode=644 ChangeLog COPYING README NEWS $dstDocDir

# --- samples (also into _docdir) ---
cp -pr  smpl/org $dstDocDir

# --- config files ---
confDir=$RPM_BUILD_ROOT%{_sysconfdir}/java
install -d $confDir
install --mode=664 sblim-cim-client2.properties sblim-slp-client2.properties $confDir

# --- jar ---
install -d $RPM_BUILD_ROOT%{_javadir}
install %{archive_folder}/lib/%{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(
  cd $RPM_BUILD_ROOT%{_javadir} && 
    ln -sf %{name}-%{version}.jar %{name}.jar;
)

# --- javadoc ---
install -d $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr %{archive_folder}/doc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}



# -----------------------------------------------------------------------------

%files
# %defattr(0644,root,root,0755)
%defattr(0644,root,root)
%config %{_sysconfdir}/java/sblim-cim-client2.properties
%config %{_sysconfdir}/java/sblim-slp-client2.properties
%doc %{_docdir}/%{name}-%{version}/COPYING
%doc %{_docdir}/%{name}-%{version}/README
%doc %{_docdir}/%{name}-%{version}/ChangeLog
%doc %{_docdir}/%{name}-%{version}/NEWS
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar


%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}


%files manual
%defattr(0644,root,root,0755)
# %doc %{_docdir}/%{name}-%{version}/README.samples
%doc %{_docdir}/%{name}-%{version}/COPYING
%doc %{_docdir}/%{name}-%{version}/org


# -----------------------------------------------------------------------------

%changelog
* Thu Dec 15 2011 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.11
  o 3459036 Linked list for RI queue not efficient for many LDs
  o 3444912 Client delay during SSL handshake
  o 3423064 Add UpdateExpiredPassword Header for Reqs from Java Client
  o 3411944 createJavaObject exception with hex uint
  o 3411879 TCK: CIM element value must match type
  o 3410126 TCK: CIM element name cannot be null
  
* Thu Sep 15 2011 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.10
  o 3409691 2.1.10 packaging issues: rpmbuild broken on Red Hat
  o 3406275 HEAD branch ONLY: sync with Experimental branch
  o 3400209 Highlighted Static Analysis (PMD) issues
  o 3397922 support OctetString
  o 3390724 Problem with Reliable Indication support in the Listener
  o 3374012 Sblim client CIMObjectPath class defect for LLA format URL
  o 3376657 Get reliable indication properties once
  o 3374206 NullPointerException caused by Indication
  o 3323310 Need the ability to override certain Global Properties
  
* Wed Jun 15 2011 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.9
  o 3311279 Repeated Instantiation of SAXParserFactory
  o 3304953 Indication URL mapped to lower case
  o 3304058 Use same date format in change history
  o 3288721 Need the function of indication reordering
  o 3206904 Indication listener deadlock causes JVM to run out sockets
  o 3297028 Instances contain CIMClassProperty with DOM parser
  o 3293248 Support for CIM_ERROR instances within ERROR
  o 3281781 fail to parse Embedded Instance parameter
  o 3277928 CIM-XML tracing cannot be enabled in the field
  o 3267429 Samples should close client
  o 3252669 setXmlTraceStream blindly closes previous stream
  o 3235440 NullPointerException when socket factory returns null
  
* Tue Mar 15 2011 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.8
  o 3197423 Server authentication with PegasusLocalAuthInfo failing
  o 3197627 testBasicConnect unit test fails on Windows
  o 3194700 Exception thrown on extrinsic methods
  o 3194680 Error in numeric keys
  o 3195069 Need support to disable SSL Handshake
  o 3185763 Reliable indication support - Phase 1
  o 3190335 Erroneous use of SystemName property in samples
  o 3186176 XML response for indication not traced
  o 3185833 missing newline when logging request/response
  o 3185824 Char16 definition includes whitespace
  o 3185818 indicationOccured URL incorrect
  o 3182121 Add Jsr48PegasusIndicationSample
  o 3154232 EmbeddedObject misspelled in javadoc

* Wed Dec 15 2010 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.7
  o 3111718 org.sblim.cimclient SSL Code is using the wrong SSL Property
  o 3109824 Move Java link from Sun to Oracle
  o 3078280 Fix for a null pointer exception in 1.3.9.1
  o 3062747 SblimCIMClient does not log all CIM-XML responces.
  
* Wed Sep 15 2010 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.6
  o 3046073 Performance hit due to socket conn. creation with timeout
  o 3048749 Hex digit parsing logic error in XMLPullParser
  o 3028518 Additional StringBuilder use
  o 3027618 Close files/readers in finally blocks
  o 3027615 Use CLASS_ARRAY_T instead of new CIMDataType(CLASS,0)
  o 3036683 HEAD branch ONLY: sync with Experimental branch
  o 3027479 Dead store to local variable
  o 3027392 Nullcheck of value previously dereferenced
  o 3026417 XMLAttributeValue does not use iHash field
  o 3026360 Handle unwritten fields
  o 3026316 XMLPullParser unused fields
  o 3026311 Vacuous comparison of integer value
  o 3026302 CIMDateTimeInterval uses # constructor instead of valueOf
  o 3023349 SLP uses # constructor instead of valueOf
  o 3023348 Listener uses # constructor instead of valueOf
  o 3023340 CIMObjectFactory uses # constructor instead of valueOf
  o 3023145 CharValue uses # constructor instead of valueOf
  o 3023143 CIMXMLParserImpl uses # constructor instead of valueOf
  o 3023141 CIMObjectPath uses # constructor instead of valueOf
  o 3023135 DADescriptor equals/compareTo issue
  o 3023120 RequestDescriptor equals/compareTo issue
  o 3023095 CIMQualifiedElementInterfaceImpl equals/hashCode issue
  o 3022554 Flushing socket ignores skip() return code
  o 3022541 File descriptor leak in sample/unittest
  o 3022524 iSortedValueEntries not serializable in Serializable class
  o 3022519 ServiceLocationAttribute.equals() compares same array
  o 3022501 Possible integer overflow in getTotalUSec
  o 3019252 Methods concatenate strings using + in a loop
  o 3019214 SLP equals methods assume too much
  o 3018178 CIMDateTimeInterval clean up
  o 3004779 TCK: CIMDataType not throwing IllegalArgumentException
  o 3004762 HTTPClient infinite loop for HTTP 407
  
* Tue Jun 15 2010 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.5
  o 3001333 CIMMethod class ignores propagated parameter
  o 3001680 CIMQualifierElementInterfaceImpl changes qualifiers
  o 3001359 XMLPullParser.CharString equals() method broken
  o 3001357 CIMDeleteNameSpaceOp name clash
  o 3001353 HttpHeaderParser ignores return value of toLowerCase()
  o 3001345 File handle leaks in HttpSocketFactory and LogAndTraceBroker
  o 3001243 Overview HTML out of date
  o 2997865 Infinite loop in HttpClient
  o 2994776 http 401 gives CIM_ERR_FAILED instead of CIM_ERR_ACCESS_DENIED
  o 2994252 CIMDateTimeInterval.getTotalMilliseconds() not unit tested
  o 2994249 CIMDateTimeInterval(long) calculates milliseconds
  o 2992349 CIMDateTimeInterval hr/min/sec max is 23/59/59, not 24/60/60
  o 2989424 TCK: CIMDateTimeInterval constructor
  o 2989367 CIMDateTimeInterval(long) constructor range wrong
  o 2990370 Development/unittest HTML out of date
  o 2974884 Exception when attaching 2 CDRoms with invoke method
  o 2978722 PasswordCredential(char[]) constructor is wrong
  o 2975989 TCK: CIMQualifierType constructor does not handle null
  o 2975975 TCK: CIMObjectPath(String) does not handle null
  o 2975917 TCK: CIMClass.getProperty() does not handle null property
  o 2975885 TCK: CIMXXX.hasQualifierValue(null,null) returns true
  o 2973300 TCK: CIMDateTimeXXX.compareTo() does not handle null
  o 2973230 TCK: UnsignedInteger64.equals() does not handle null
  o 2973233 TCK: UnsignedIntegerNN.hashCode() not working
  o 2972697 Fix spelling errors in HTML files

* Mon Mar 15 2010 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.4
  o 2970881 Add property to control EmbeddedObject case
  o 2942520 IPv6 link local address with scope_id including a dot not supported
  o 2964463 WBEMClient.initialize() throws wrong exception
  o 2963502 Add XML tracing to sample code
  o 2957387 EmbededObject XML attribute must not be all uppercases
  o 2956716 Jsr48IndicationSample hardcoded namespace
  o 2961592 Remove WBEMClient.setLocales() UnsupportedOperationException
  o 2959586 Sync up WBEMClient javadoc with JSR48 1.0.0
  o 2959264 Sync up javax.client.* javadoc with JSR48 1.0.0
  o 2959240 Sync up javax.listener.* javadoc with JSR48 1.0.0
  o 2959235 Update build.xml copyright year
  o 2959039 Fix WBEMException.toString() logic
  o 2958990 Remove WBEMException.CIM_ERR_TYPE_MISMATCH
  o 2958941 Sync up javax.wbem.* javadoc with JSR48 1.0.0
  o 2913938 Duplicate CIM requests with identical message ID
  o 2946113 First steps code snippet has compile errors
  o 2944830 Fix spelling of checkGranurality()
  o 2944842 Missing thrown ArrayIndexOutOfBoundsException
  o 2944839 Remove redundant toString() methods
  o 2944833 Need private setValue in UnsignedInteger8
  o 2944826 getUTCOffset() incorrect if not significant field
  o 2944824 Missing getXmlSchemaName() in CIMObjectPath
  o 2944219 Problem with pull operations using client against EMC CIMOM
  o 2935258 Sync up javax.cim.* javadoc with JSR48 1.0.0
  o 2930341 Sync up WBEMClientConstants with JSR48 1.0.0
  o 2927029 Unit test fails on Java 6
  o 2909941 RequestStateChange gives wrong exception/error id
  o 2912490 NullPointerException when invoking getInstance

* Tue Dec 15 2009 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.3
  o 2912104 Sync up javax.wbem.* with JSR48 1.0.0
  o 2907527 Fix SLP properties issues
  o 2901216 lost IndicationURL for IndcationListener.indicationOccured
  o 2903373 Java doc incorrect
  o 2900875 Javadoc should link to external Java5 Objects / APIs
  o 2886829 JSR48 new APIs: referenceClasses & referenceInstances
  o 2899859 javax.wbem.client missing JSR48 credential/principal APIs
  o 2899389 Password maximum length of 16?
  o 2888774 support POST retry on HTTP error 505
  o 2878054 Pull Enumeration Feature (PULL Parser)
  o 2884718 Merge JSR48 and SBLIM client properties
  o 2882448 Add WBEMClientConstants from JSR48
  o 2858933 JSR48 new APIs: associatorClasses & associatorInstances
  o 2870455 Missing CLASS_ARRAY_T in CIMDataType
  o 2839595 SLP discovery fails on Unix IPv6 systems
  o 2865222 enumerateQualifierTypes shouldn't require a class name
  o 2845128 CIMObjectPath.toString() misses host
  o 2846231 connection failure on CIMOM w/o user/pw
  o 2860081 Pull Enumeration Feature (DOM Parser)

* Tue Sep 15 2009 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.2
  o 2849970 createVALUEARRAY fails to create reference array
  o 2845211 Pulled Enumeration Support (SAX Parser)
  o 2834838 Add interface to retrieve version number and product name
  o 2817962 socket creation connects w/o a timeout
  o 2823494 Change Boolean constructor to static

* Mon Jun 15 2009 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.1
  o 2806362 Missing new CIMDateTimeAbsolute.getUTCOffset() method
  o 2797550 Make code compatible with JSR48 / Java Generics 
  o 2797696 Input files use unchecked or unsafe operations 
  o 2795671 Add Type to Comparable <T> 
  o 2799260 Fix left over @author tag from Java5 upgrade 
  o 2798931 Fix spelling of WBEMListenerFactory.getPROTOCOLS()
  o 2791860 Export instance to mof, wrong syntax
  o 2787464 lang exception in Chinese env with Java client 2.0.7
  o 2784078 Code cleanup: messages_XX.properties
  o 2763216 Code cleanup: visible spelling/grammar errors
  o 2750520 Code cleanup from empty statement et al
  o 2714989 Code cleanup from redundant null check et al

* Thu Mar 12 2009 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.1.0
  o 2680372 Eliminate duplicate entries in javadoc allclasses-frame.html
  o 2641758 CIM Client does not recognize HTTP extension headers
  o 2620505 EmbeddedObject qualifier is missing from CIMClass
  o 2433593 isArray returns true for method parameters of type reference
  o 2531371 Upgrade client to JDK 1.5 (Phase 2)
  o 2573575 Fix build.xml to allow file names >100 chars
  o 2524131 Upgrade client to JDK 1.5 (Phase 1)

* Fri Dec 12 2008 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.0.9
  o 2414503 SLPConfig : parseList not returning populated list
  o 2412389 Test case failure: Java5 Complier : CIMDateTimeAbsoluteTest
  o 2382763 HTTP header field Accept-Language does not include *
  o 2372030 Add property to control synchronized SSL handshaking
  o 2315151 Jsr48IndicationSample does not work 
  o 2227442 Add missing serialVersionUID
  o 2210455 Enhance javadoc, fix potential null pointers
  o 2204488 Fix / clean code to remove compiler warnings

* Fri Sep 12 2008 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.0.8
  o 2093708 HTTP 400 - Bad Request, CIMError: request-not-valid
  o 2087969 VALUE.ARRAY used in request for array of references
  o 2087975 can't set the pPropagated in WBEMClient.enumerateClasses()
  o 2038305 SAXException SBLIM Java Client V2.0.7
  o 2034342 HttpClient not closed on cimclient close
  o 2013628 SAXException when listing classes
  o 2002599 M-POST not supported in java-client

* Mon Jun 30 2008 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.0.7
  o 2003590 Change licensing from CPL to EPL
  o 1963102 NullPointerException when getting qualifiers
  
* Thu Jun 12 2008 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.0.6
  o 1992337 2.0.6 packaging issues
  o 1944875 Indications with embedded objects are not accepted
  o 1917321 CIMObjectPath("CIM_Memory","/root/ibmsd") broken
  o 1963762 connection leak in WBEMClientCIMXML
  o 1949000 setLocales() is empty
  o 1950819 SLP error: "java.io.IOException" on Linux and IPv6
  o 1949918 malformed service URL crashes SLP discovery
  o 1931621 CIMDateTimeAbsolute(Calendar) does not respect DST
  o 1931216 In HTTPClient need to get status before closing connection
  o 1917309 "/root:__NAMESPACE" not valid CIMObjectPath

* Wed Mar 12 2008 Dave Blaschke <blaschke@us.ibm.com>
- New release 2.0.5
  o 1911400 Source RPM file on SourceForge is broken
  
* Tue Feb 26 2008 Alexander Wolf-Reber <a.wolf-reber@de.ibm.com>
- New release 2.0.4
  o 1892046 Basic/digest authentication problem for Japanese users
  o 1849235 DTStringWriter.writeSigned parameter pDigits is not used
  o 1855726 CIMInstance.deriveInstance is setting wrong CIMObjectPath
  o 1892103 SLP improvements
  o 1804402 IPv6 ready SLP
  o 1832635 less strict parsing for IPv6 hostnames
  o 1848607 Strict EmbeddedObject types
  o 1827728 embeddedInstances: attribute EmbeddedObject not set
  o 1820763 Supporting the EmbeddedInstance qualifier
  o 1815707 TLS support
  o 1796339 Serializable interface missing from internal componentry
  o 1783288 CIMClass.isAssociation() not working for retrieved classes.
  o 1776114 Cannot derive instance of class CIM_IndicationSubscription
  o 1741654 Header mismatch error on ModifyInstance
  o 1769504   Type identification for VALUETYPE="numeric"

* Fri Aug 17 2007 Alexander Wolf-Reber <a.wolf-reber@de.ibm.com>
- New release 2.0.3
  o 1745282 Uniform time stamps for log files
  o 1742873 IPv6 ready cim-client
  o 1729361 Multicast discovery is broken in DiscovererSLP
  o 1737141 Sync up with JSR48 evolution
  o 1737123 Differences to JSR48 public review draft
  o 1736318 Wrong object path in HTTP header
  o 1735693 Empty VALUE.ARRAY elements are parsed as nulls
  o 1735614 Wrong ARRAYSIZE attribute handling in SAX/PULL
  o 1734936 DiscovererSLPTest fails in some environments
  o 1734888 Wrong reference building in METHODCALL request
  o 1723607 IPv6 support in WBEM-URI strings

* Fri May 25 2007 Alexander Wolf-Reber <a.wolf-reber@de.ibm.com>
- New release 2.0.2
  o 1720707 Conventional Node factory for CIM-XML SAX parser
  o 1719991 FVT: regression ClassCastException in EmbObjHandler
  o 1712656 Correct type identification for SVC CIMOM
  o 1715612 FVT: Status 0 in trailer is parsed as error
  o 1715511 FVT: Wrong HTTP header values
  o 1715027 FVT: Make message id random
  o 1714902 FVT: Threading related weak spots
  o 1714853 FVT: Inexplicit error when operation is invoked on closed client
  o 1714878 FVT: Empty string property values are parsed as nulls
  o 1715053 FVT: No forced retry on HTTP 501/510
  o 1714184 FVT: NPE on WBEMClientCIMXML.init()
  o 1711092 Some fixes/additions of log&trace messages
  o 1710066 LocalAuth fails for z/OS Pegasus
  o 1669961 CIMTypedElement.getType() =>getDataType()
  o 1669225 Ctor CIMDataType(int) shall be private
  o 1689085 Embedded object enhancements for Pegasus
  o 1678915 Integrated WBEM service discovery via SLP
  o 1698278 Unit tests fail on Hungarian locale
  o 1678807 Minor CIMDateTime suggestions
  o 1686977 Change package structure
  o 1679620 Ant build fails with javadoc error
  o 1679534 wrong ValueObjectNode.testChild()
  o 1660756 Embedded object support
  o 1671502 Remove dependency from Xerces
  o 1663270 Minor performance problems
  o 1660743 SSLContext is static
  o 1660575 Chunking broken on SUN JRE
  o 1656285 IndicationHandler does not accept non-Integer message ID

* Tue Feb 13 2007 Alexander Wolf-Reber <a.wolf-reber@de.ibm.com>
- New release 2.0.1
  o 1565892 Make SBLIM client JSR48 compliant

* Mon Feb 12 2007 Wolfgang Taphorn <taphorn@de.ibm.com>
- Initial Version
